<?php

class PersonController extends RController
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	// public $layout='//layouts/column2';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'rights',
			'postOnly + delete', // we only allow deletion via POST request
		);
	}



	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$itemName = 'hr_person';
		$user_id = Yii::app()->user->getId();
		$authorizer = Rights::getAuthorizer();
		$authAssignments = $authorizer->authManager->getAuthAssignment($itemName, $user_id);

		$this->render('view', array(
			'model' => $this->loadModel($id),
			'authAssignments' => $authAssignments,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new Person('create');

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);
		$roles = Rights::getAssignedRoles(Yii::app()->user->Id);
		foreach ($roles as $role) {
			$roleName = $role->name;
		}
		$ro = $roleName;

		if (isset($_POST['Person'])) {

			$rnd = uniqid();

			$model->attributes = $_POST['Person'];

			$model->image = CUploadedFile::getInstance($model, 'image');
			if ($model->image != null && $model->validate(['image'])) {
				$uploadedFile = $model->image;
				$fileName = "{$rnd}-{$uploadedFile}";  // random number + file name
				$model->image = $fileName;
				$uploadedFile->saveAs(Yii::app()->basePath . '/../uploads/Person/' . $fileName);
			} else {
				$model->image = "avatar.jpg";
			}

			if ($model->save())
				$this->redirect(array('view', 'id' => $model->id));
		}

		$this->render('create', array(
			'model' => $model,
			'rolename' => $ro,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		$roles = Rights::getAssignedRoles(Yii::app()->user->Id);
		foreach ($roles as $role) {
			$roleName = $role->name;
		}
		$ro = $roleName;

		$old_image = $model->image;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if (isset($_POST['Person'])) {
			$model->attributes = $_POST['Person'];
			ImageHelper::resize($model, 'image', $old_image);

			if ($model->save())
				$this->redirect(array('view', 'id' => $model->id));
		}

		$this->render('update', array(
			'model' => $model,
			'rolename' => $ro,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if (!isset($_GET['ajax'])) {
			Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
		}
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider = new CActiveDataProvider('Person');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$roles = Rights::getAssignedRoles(Yii::app()->user->Id);
		foreach ($roles as $role) {
			$roleName = $role->name;
		}
		$ro = $roleName;
		$model = new Person('search');
		$model->unsetAttributes();  // clear any default values
		if (isset($_GET['Person']))
			$model->attributes = $_GET['Person'];

		$this->render('admin', array(
			'model' => $model,
			'rolename' => $ro,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Person the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model = Person::model()->findByPk($id);
		if ($model === null)
			throw new CHttpException(404, 'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param Person $model the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if (isset($_POST['ajax']) && $_POST['ajax'] === 'person-form') {
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
	///////////////////////////////////////////////////////////////////////

	public function actionSiteView($id)
	{
		$model = new Person('search');
		$model->unsetAttributes();  // clear any default values
		if (isset($_GET['Person']))
			$model->attributes = $_GET['Person'];
		$this->render('site/index', array(
			'model' => $this->loadModel($id),
		));
	}
}
